controllers/SiteController.php
<?php

namespace app\controllers;
use yii\data\SqlDataProvider;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\Ciclista;
use app\models\Lleva;
use app\models\Puerto;
use app\models\Etapa;
use yii\data\ActiveDataProvider;


class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    
    /*
     * Creado esta accion
     */
    
    public function actionCrud(){
        return $this->render('gestion');
    }
    
     
    public function actionConsulta3a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()->select("dorsal")->where("nomequipo='Banesto' AND edad BETWEEN 25 AND 32"),
            'pagination'=>[
                'pageSize'=>0,
                ]
        ]);
                
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=>"Consulta 3",
            "enunciado"=>"Listar el dorsdal de los ciclistas que son de Banesto y cuya edad esta entre 25 y 32.",
            "sql"=>"SELECT dorsal FROM ciclista WHERE nomequipo='Banesto' AND edad BETWEEN 25 AND 32",
        ]);
    }
    
     public function actionConsulta3(){
            // mediante DAO
               
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT dorsal FROM ciclista WHERE nomequipo='Banesto' AND edad BETWEEN 25 AND 32" ,
                'pagination'=>[
                'pageSize'=>0,
                ],
            
            
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=>"Consulta 3",
            "enunciado"=>"Listar el dorsdal de los ciclistas que son de Banesto y cuya edad esta entre 25 y 32.",
            "sql"=>"SELECT dorsal FROM ciclista WHERE nomequipo='Banesto' AND edad BETWEEN 25 AND 32",
        ]); 
    }
    
    public function actionConsulta4a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Ciclista::find()->select("dorsal")
                ->where("nomequipo='Banesto' OR edad BETWEEN 25 AND 32"),
            'pagination'=>[
                'pageSize'=>0,
                ]
        ]);
                
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=>"Consulta 4",
            "enunciado"=>"Listar el dorsal de los ciclistas que son de Banesto o cuya edad esta entre 25 y 32.",
            "sql"=>"SELECT dorsal FROM ciclista WHERE nomequipo='Banesto' OR edad BETWEEN 25 AND 32",
        ]);
    }
    
     public function actionConsulta4(){
            // mediante DAO
        
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT dorsal FROM ciclista WHERE nomequipo='Banesto' OR edad BETWEEN 25 AND 32" ,
        
            'pagination'=>[
                'pageSize'=>0,
                ],
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['dorsal'],
            "titulo"=>"Consulta 4",
            "enunciado"=>"Listar el dorsal de los ciclistas que son de Banesto o cuya edad esta entre 25 y 32.",
            "sql"=>"SELECT dorsal FROM ciclista WHERE nomequipo='Banesto' OR edad BETWEEN 25 AND 32;",
        ]);
    }
    
      
    
    public function actionConsulta8a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Puerto::find()->select("nompuerto")->where ("altura BETWEEN 1000 AND 2000 OR altura >2400")
                ,
            'pagination'=>[
                'pageSize'=>10,
                ]
        ]);
                
           return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nompuerto'],
            "titulo"=>"Consulta 8",
            "enunciado"=>"Listar el nombre de los puertos cuya altura entre 1000 y 2000 que la altura sea mayorque 2400.",
            "sql"=>"SELECT nompuerto FROM puerto WHERE altura BETWEEN 1000 AND 2000 OR altura >2400",
        ]);
    }
    
     public function actionConsulta8(){
            // mediante DAO
        $numero=Yii::$app
                ->db->createCommand("SELECT COUNT(*) FROM (SELECT nompuerto FROM puerto WHERE altura BETWEEN 1000 AND 2000 OR altura >2400) c1" )
                ->queryScalar(); // cuenta los registros que hay en la consulta y lo guarda $numero
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT nompuerto FROM puerto WHERE altura BETWEEN 1000 AND 2000 OR altura >2400" ,
            'totalCount' => $numero, // se lo pasamos de arriba
            'pagination'=>[
                'pageSize'=>10,
                ],
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nompuerto'],
            "titulo"=>"Consulta 8",
            "enunciado"=>"Listar el nombre de los puertos cuya altura entre 1000 y 2000 que la altura sea mayorque 2400.",
            "sql"=>"SELECT nompuerto FROM puerto WHERE altura BETWEEN 1000 AND 2000 OR altura >2400",
        ]);
    } 
    
    public function actionConsulta12a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Puerto::find()->select("count(distinct dorsal) as nciclistas")   
                ,
            'pagination'=>[
                'pageSize'=>3,
                ]
        ]);
                
           return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nciclistas'],
            "titulo"=>"Consulta 12",
            "enunciado"=>"Listar el número de ciclistas que hayan ganado algún puerto.",
            "sql"=>"SELECT count(DISTINCT dorsal) nciclistas FROM puerto",
        ]);
    }
    
     public function actionConsulta12(){
            // mediante DAO
        $numero=Yii::$app
                ->db->createCommand("SELECT 1" )
                ->queryScalar(); // cuenta los registros que hay en la consulta y lo guarda $numero
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT count(DISTINCT dorsal) nciclistas FROM puerto" ,
            'totalCount' => $numero, // se lo pasamos de arriba
            'pagination'=>[
                'pageSize'=>3,
                ],
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['nciclistas'],
            "titulo"=>"Consulta 12",
            "enunciado"=>"Listar el número de ciclistas que hayan ganado algún puerto.",
            "sql"=>"SELECT count(DISTINCT dorsal) nciclistas FROM puerto",
        ]);
    } 
    
     public function actionConsulta14a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Puerto::find()->select("AVG(altura) as maltura")
                ,
            'pagination'=>[
                'pageSize'=>0,
                ]
        ]);
                
           return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['maltura'],
            "titulo"=>"Consulta 14",
            "enunciado"=>"Indicar la altura media de los puertos.",
            "sql"=>"SELECT AVG(altura) FROM puerto",
        ]);
    }
    
     public function actionConsulta14(){
            // mediante DAO
        $numero=Yii::$app
                ->db->createCommand("SELECT  1" )
                ->queryScalar(); // cuenta los registros que hay en la consulta y lo guarda $numero
        
        $dataProvider= new SqlDataProvider([
            'sql'=> "SELECT AVG(altura) AS maltura FROM puerto" ,
            'totalCount' => $numero, // se lo pasamos de arriba
            'pagination'=>[
                'pageSize'=>0,
                ],
        ]);
        
        return $this->render("resultado",[
            "resultados"=>$dataProvider,
            "campos"=>['maltura'],
            "titulo"=>"Consulta 14",
            "enunciado"=>"Indicar la altura media de los puertos.",
            "sql"=>"SELECT AVG(altura) FROM puerto",
        ]);
    }
    
    public function actionConsulta18a(){
        // mediante active record
        $dataProvider=new ActiveDataProvider([
            'query'=> Lleva::find()->select("dorsal, código, COUNT(*) numero")->groupBy("dorsal, código")
                ,
            'pagination'=>[
                'pageSize'=>10,
                ]
        ]);
                
           return $this->render("resultado",[
            "resultados"=>$dataProvider,

views/site/_listar.php
        <tr>
            <td><h3><?= $model->dorsal ?>  </h3></td>
            <td><h3><?= $model->código ?>  </h3></td>
            <td><h3><?= $model->numero ?>  </h3></td>
        </tr>
        

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/gestion.php
<?php

use yii\helpers\Html;

echo Html::a('Ciclistas',
        ['ciclista/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Etapas',
        ['etapa/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Equipos',
        ['equipo/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Lleva',
        ['lleva/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Maillot',
        ['maillot/index'],
        ['class' => 'btn btn-primary btn-large']
        );

echo ' ';

echo Html::a('Puerto',
        ['puerto/index'],
        ['class' => 'btn btn-primary btn-large']
        );



?>

views/site/index.php
<?php
use yii\bootstrap\Html;
/* @var $this yii\web\View */

$this->title = 'My Yii Application';
?>

<div class="site-index">

    <div class="jumbotron">
        <h1>consultas de seleccion 3</h1>
Application
        <p class="lead">Modulo 3 Unidad 2</p>
    </div>

    <div class="body-content">

        <div class="row">
            
             <!-- tercera consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 3</h3>
                      <p>Listar el dorsdal de los ciclistas que son de Banesto y cuya edad esta entre 25 y 32.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta3a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta3'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
             
              <!-- cuarta consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 4</h3>
                      <p>Listar el dorsal de los ciclistas que son de Banesto o cuya edad esta entre 25 y 32.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta4a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta4'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              <!-- octava consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 8</h3>
                      <p>Listar el nombre de los puertos cuya altura entre 1000 y 2000 que la altura sea mayorque 2400.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta8a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta8'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
              <!-- duodecima consulta  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 12</h3>
                      <p>Listar el número de ciclistas que hayan ganado algún puerto.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta12a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta12'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
              
                            <!-- catorce  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 14</h3>
                      <p>Listar el número de ciclistas que hayan ganado algún puerto.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta14a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta14'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>
                            
                            <!-- dieciocho  -->
            
                <div class="col-sm-6 col-md-4">
                  <div class="thumbnail">
                    <div class="caption">
                      <h3>Consulta 18</h3>
                      <p>Listar el número de ciclistas que hayan ganado algún puerto.</p>
                      <p>
                          <?= Html::a('Active Record',['site/consulta18a'],['class' => 'btn btn-primary btn-large']);?>
                          <?= Html::a('DAO',['site/consulta18'],['class' => 'btn btn-default btn-large']);?>
                          <?= Html::a('ListView',['site/consulta18b'],['class' => 'btn btn-default btn-large']);?>
                      </p>
                    </div>
                  </div>
                </div>

              
        </div>

    </div>
</div>

views/site/listView.php
<div>
    <h1>Listado de todos los registros</h1>
    
</div>

<?php
use yii\widgets\ListView;
?>
<table border="5">
    <thead>
        <tr>
            <th>Dorsal</th>
            <th>Código</th>
            <th>Número veces</th>
        </tr>
    </thead>
      <tbody>
<?php
echo ListView::widget([
    'dataProvider' => $dataProvider,
    'itemView' => '_listar',
]);
?>
  
    </tbody>
</table>

views/site/resultado.php
<?php
use yii\grid\GridView;

?>


 <div class="jumbotron">
        <h1><?= $titulo?></h1>
        <p class="lead"><?=$enunciado?></p>
            <div class="well"> 
            <?= $sql?>
            </div>
    </div>
    
    
    <?= GridView::widget([
        'dataProvider' => $resultados,
        'columns' => $campos,
                
    ]);?>